## lablgtk3 3.0~beta3

=== src/Makefile ===
# Makefile for lablgtk.

COMPILER = $(CAMLC) $(MLFLAGS) $(MLBYTEFLAGS) -w s-3+52 -warn-error A-52 -c
LINKER = $(CAMLC) $(MLFLAGS) $(MLBYTEFLAGS)
COMPOPT = $(CAMLOPT) $(MLFLAGS) -w s -c
LINKOPT = $(CAMLOPT) $(MLFLAGS)
LIBRARIAN = $(CAMLMKLIB) -verbose -ocamlc "$(CAMLC)" -ocamlopt "$(CAMLOPT)"
TOPLEVEL = $(CAMLMKTOP) $(MLFLAGS)
CAMLP4 = $(CAMLP4O) pr_o.cmo

CONFIG = ../config.make

# protect against missing definitions
BINDIR = ""
LIBDIR = ""
INSTALLDIR = $(LIBDIR)/lablgtk3
DLLDIR = $(LIBDIR)/stublibs

include $(CONFIG)
#GTKCFLAGS += -Werror -Wno-error=deprecated-declarations
GTKCFLAGS += -Wno-deprecated-declarations

TARGETS = varcc$(XE) lablgtktop$(XE) lablgtk3$(XB) gdk_pixbuf_mlsource3$(XE) \
	$(THINITOBJS) build.ml

all: dist byte
world: dist byte $(CAMLBEST)
install: findlib-install
uninstall: findlib-uninstall

MLLIBS = lablgtk.cma
CLIBS = liblablgtk3$(XA)
#MLLINK = unix.cma str.cma

# For -DG_LOG_DOMAIN=\"LablGTK\"
ifneq ($(TOOLCHAIN),msvc)
GTKCFLAGS += -imacros ml_domain.h
else
GTKCFLAGS += /FI ml_domain.h
endif

# compile using a custom version of mlvalues.h, where value is abstract
ifdef ABSVALUE
GTKCFLAGS += -Iabsvalue -DABSVALUE
endif

ifdef DEBUG
CFLAGS = -g $(GTKCFLAGS)
CUSTOM = -custom
#MLLINK += -cclib -lcamlrund
MLBYTEFLAGS = -g -dtypes
else
CFLAGS = -DG_DISABLE_ASSERT -DG_DISABLE_CAST_CHECKS $(GTKCFLAGS)
ifneq ($(TOOLCHAIN),msvc)
CFLAGS += -O
endif
endif

ifeq ($(THREADS_LIB),system)
THFLAGS = -thread
else
THFLAGS = -vmthread
CUSTOM = -custom
endif
THLINK = unix.cma threads.cma

ifdef USE_CC
CCOMPILER = $(CC) -c -I"$(LIBDIR)" $(CFLAGS)
else
CCOMPILER = $(CAMLC) -c -ccopt '$(CFLAGS)' -verbose
endif

ifdef USE_GL
ifdef LABLGLDIR
MLFLAGS += -I $(LABLGLDIR)
endif
MLLINK += lablgl.cma
MLLIBS += lablgtkgl.cma
CLIBS += liblablgtkgl3$(XA)
GLMLOBJS = glGtk.cmo
GLCOBJS = ml_gtkgl$(XO)
endif

#ifdef USE_GNOME
#MLLIBS += lablgnome.cma
#CLIBS += liblablgnome$(XA)
#GNOMEMLOBJS = gtkXmHTML.cmo gHtml.cmo
#GNOMECOBJS = ml_gtkxmhtml$(XO)
#endif

TARGETS += lablgladecc$(XE)

ifdef USE_GNOMECANVAS
MLLIBS += lablgnomecanvas.cma
CLIBS += liblablgnomecanvas$(XA)
GNOMECANVASMLOBJS = gnomeCanvas.cmo gnoCanvas.cmo
GNOMECANVASCOBJS = ml_gnomecanvas$(XO)
endif

ifdef USE_GNOMEUI
MLLIBS += lablgnomeui.cma
CLIBS += liblablgnomeui$(XA)
GNOMEUIMLOBJS = gnomeDruid.cmo gnoDruid.cmo
GNOMEUICOBJS = ml_gnomedruid$(XO)

ifdef USE_PANEL
MLLIBS += lablpanel.cma
CLIBS += liblablpanel$(XA)
PANELMLOBJS = panel.cmo
PANELCOBJS = ml_panel$(XO)
endif
endif


ifdef USE_RSVG
MLLIBS += lablrsvg.cma
CLIBS += liblablrsvg$(XA)
RSVGMLOBJS = rsvg.cmo
RSVGCOBJS = ml_rsvg$(XO)
$(RSVGCOBJS) : CFLAGS+=$(HAVE_SVGZ)
endif

ifdef USE_GTKSPELL
MLLIBS += lablgtkspell.cma
CLIBS += liblablgtkspell3$(XA)
GTKSPELLMLOBJS = gtkSpell.cmo
GTKSPELLCOBJS = ml_gtkspell$(XO)
endif

ifdef USE_GTKSOURCEVIEW3
ml_gtksourceview3.o: CFLAGS=$(GTKSOURCEVIEW3CFLAGS)
MLLIBS += lablgtksourceview3.cma
CLIBS += liblablgtksourceview3$(XA)
GTKSOURCEVIEW3MLOBJS = gtkSourceView3.cmo gSourceView3.cmo
GTKSOURCEVIEW3COBJS = ml_gtksourceview3$(XO)
GTKSOURCEVIEW3MLOBJSENUM = sourceView3Enums.cmo
GTKSOURCEVIEW3PROPS = gtkSourceView3.props
BEFORE_DEPEND += $(GTKSOURCEVIEW3PROPS:%.props=%Props.ml) $(GTKSOURCEVIEW3PROPS:%.props= o%Props.ml) $(GTKSOURCEVIEWMLOBJSENUM:%.cmo=%.ml)
EXTRA_OBJS += $(GTKSOURCEVIEW3MLOBJSENUM)
GTKSOURCEVIEW3ALLMLOBJS = $(GTKSOURCEVIEW3MLOBJSENUM) \
	$(GTKSOURCEVIEW3PROPS:%.props=%Props.cmo) \
	$(GTKSOURCEVIEW3PROPS:%.props=o%Props.cmo) $(GTKSOURCEVIEW3MLOBJS)
lablgtksourceview3.cma liblablgtksourceview3$(XA): \
  $(GTKSOURCEVIEW3COBJS) $(GTKSOURCEVIEW3ALLMLOBJS)
	$(LIBRARIAN) -o lablgtksourceview3 $^ $(GTKSOURCEVIEW3LIBS)
lablgtksourceview3.cmxa: \
  $(GTKSOURCEVIEW3COBJS) $(GTKSOURCEVIEW3ALLMLOBJS:.cmo=.cmx)
	$(LIBRARIAN) -o lablgtksourceview3 $^ $(GTKSOURCEVIEW3LIBS)
lablgtksourceview3.cmxs: DYNLINKLIBS=$(GTKSOURCEVIEW3_LIBS)
GTKSOURCEVIEWINSTALL=gtkSourceView3_types.mli
endif

ifdef USE_GTKQUARTZ
CFLAGS += -DHAS_GTKQUARTZ
endif
# Rules
.SUFFIXES: .ml .mli .cmo .cmi .cmx .cmxs .cmxa .c $(XO) .d$(XO) .var .h .opt .def .ml4
.c$(XO):
	$(CCOMPILER) $<
.cpp$(XO):
	$(CCOMPILER) $<
.c.d$(XO):
	$(CAMLC) -c -ccopt '-MT -DCAML_DLL -Fo$@ $(CFLAGS)' $<
.ml.cmo:
	$(COMPILER) $(PRINCIPAL) $<
.mli.cmi:
	$(COMPILER) $<
.ml.cmx:
	$(COMPOPT) $<
ifneq ($(CAMLP4O),no)
.ml4.ml:
	$(CAMLP4O) -impl $< -o $@
endif
#.ml4.cmo:
#	$(CAMLC) -c -pp "$(CAMLP4O) -impl" -impl $<
.cmxa.cmxs:
	$(CAMLOPT) -verbose -o $@ -shared -linkall -I . \
        -ccopt '$(filter -L%, $(DYNLINKLIBS))' $<

%_tags.h %_tags.c %Enums.ml: %_tags.var varcc$(XE)
	./varcc $<

%Props.ml o%Props.ml: %.props propcc$(XE)
	./propcc $<

# Files
GTKOBJS =  ml_gtk$(XO) ml_pango$(XO) ml_gtkaction$(XO) \
	ml_gtkbin$(XO) ml_gtkbutton$(XO) \
	ml_gtkassistant$(XO) \
	ml_gtkedit$(XO) ml_gtkfile$(XO) \
	ml_gtkmenu$(XO) ml_gtkmisc$(XO) \
	ml_gtkpack$(XO) ml_gtkrange$(XO) ml_gtkstock$(XO) \
	ml_gtktext$(XO) ml_gtktree$(XO) ml_gtkbuilder$(XO)
COBJS = ml_gdkpixbuf$(XO) ml_gdk$(XO) ml_glib$(XO) ml_gobject$(XO) \
	ml_gpointer$(XO) ml_gvaluecaml$(XO) wrappers$(XO) $(GTKOBJS)
GTKPROPS += gtkBase.props gtkBin.props gtkButton.props gtkEdit.props \
	gtkMenu.props gtkMisc.props gtkPack.props \
	gtkRange.props gtkText.props gtkTree.props gtkFile.props \
	gtkAction.props gtkAssistant.props gtkBuilder.props
MLOBJS1 =  gaux.cmo gpointer.cmo gutf8.cmo glib.cmo gobject.cmo
ENUMOBJS += gdkEnums.cmo pangoEnums.cmo gtkEnums.cmo
MLOBJS2 = pango.cmo gdk.cmo gdkEvent.cmo gdkKeysyms.cmo gdkPixbuf.cmo \
	gtk.cmo gtkSignal.cmo gtkStock.cmo gtkObject.cmo
MLOBJS3 = gtkData.cmo gtkBase.cmo gtkPack.cmo gtkButton.cmo \
	gtkAssistant.cmo \
	gtkMenu.cmo gtkMisc.cmo gtkWindow.cmo \
	gtkBin.cmo gtkEdit.cmo gtkRange.cmo gtkText.cmo gtkTree.cmo \
	gtkBuilder.cmo gtkFile.cmo gtkMain.cmo \
	gPango.cmo gDraw.cmo gObj.cmo ogtkBaseProps.cmo gData.cmo
MLOBJS4 = gMain.cmo gContainer.cmo gPack.cmo gButton.cmo gText.cmo \
	gMenu.cmo gMisc.cmo gTree.cmo gFile.cmo gWindow.cmo \
	gAssistant.cmo gBuilder.cmo \
	gBin.cmo gEdit.cmo gRange.cmo gAction.cmo \
	gUtil.cmo gToolbox.cmo
MLOBJS =  $(MLOBJS1) $(ENUMOBJS) $(MLOBJS2) $(GTKPROPS:.props=Props.cmo) \
	$(MLOBJS3) $(GTKPROPS:%.props=o%Props.cmo) $(MLOBJS4)
THOBJS = gtkThread.cmo
INITOBJS = gtkInit.cmo
ifdef USE_GTKQUARTZ
THINITOBJS = gtkThTop.cmo
else
THINITOBJS = gtkThInit.cmo
endif
EXTRAOBJS = $(INITOBJS) $(THOBJS) $(THINITOBJS)
ALLOBJS = $(MLOBJS) $(GLMLOBJS) $(GNOMEMLOBJS) \
	$(RSVGMLOBJS) $(GNOMECANVASMLOBJS) $(GNOMEUIMLOBJS) $(PANELMLOBJS) \
	$(GTKSOURCEVIEW3MLOBJS) $(GTKSPELLMLOBJS) \
	$(INITOBJS)
ALLTHOBJS = $(THOBJS) $(THINITOBJS)
PROPOBJS = $(GTKPROPS:%.props=%Props.cmo) $(GTKPROPS:%.props=o%Props.cmo)
ML4SRC = check_externals.ml propcc.ml varcc.ml

# Targets
byte:: $(TARGETS) $(INITOBJS)
opt::  $(TARGETS) lablgtkopt

depend:
	$(MAKE) real-depend USE_GL=1 USE_RSVG=1 \
	  USE_GNOMECANVAS=1 USE_GNOMEUI=1 USE_PANEL=1 USE_GTKSPELL=1 \
	  USE_GTKSOURCEVIEW3=1
real-depend: $(ENUMOBJS:.cmo=.ml) $(PROPOBJS:.cmo=.ml) $(BEFORE_DEPEND)
	ocamldep $(ALLOBJS:.cmo=.ml) $(PROPOBJS:.cmo=.ml) \
	  $(ALLTHOBJS:.cmo=.ml) $(BEFORE_DEPEND) *.mli > .depend

ifeq ($(THREADS_LIB),no)
lablgtktop$(XE): $(MLLIBS) $(CONFIG)
	$(TOPLEVEL) $(CUSTOM) -o $@ $(MLLINK) -I . $(MLLIBS)
else
lablgtktop$(XE): $(MLLIBS) $(THOBJS) $(CONFIG)
	$(TOPLEVEL) $(THFLAGS) $(CUSTOM) -o $@ $(THLINK) $(MLLINK) \
	   -I . $(MLLIBS) $(THOBJS)
endif

lablgtk3: Makefile $(CONFIG) lablgtk3.in
	sed -e "s|@INSTALLDIR@|$(LABLGTKDIR)|g" \
	    -e "s|@LABLGLDIR@|$(LABLGLDIR)|g" \
	    -e "s|@MLLIBS@|$(MLLINK) $(MLLIBS)|g" \
	    -e "s|@INITOBJS@|$(INITOBJS)|g" \
	    -e "s|@THOBJS@|$(THOBJS)|g" \
	    -e "s|@THINITOBJS@|$(THINITOBJS)|g" \
	    -e "s|@USEDLL@|$(HAS_DLL_SUPPORT)|g" \
	    -e "s|@THREADS_LIB@|$(THREADS_LIB)|g" \
	    < lablgtk3.in > $@
	chmod 755 $@

lablgtk3.bat: lablgtk3.bat.in
	cp lablgtk3.bat.in lablgtk3.bat

build.ml: Makefile $(CONFIG) build.ml.in
	sed -e "s|@LABLGTK_MLS@|$(MLOBJS:.cmo=)|" \
	    -e "s|@EXTRA_MLS@|$(EXTRAOBJS:.cmo=)|" \
	    -e "s|@PROP_MLS@|$(PROPOBJS:.cmo=)|" \
	    -e "s|@GTKLIBS@|$(GTKLIBS)|" \
	    -e "s|@RSVG_MLS@|$(RSVGMLOBJS:.cmo=)|" \
	    -e "s|@RSVG_LIBS@|$(RSVGLIBS)|" \
	    -e "s|@CANVAS_MLS@|$(GNOMECANVASMLOBJS:.cmo=)|" \
	    -e "s|@CANVAS_LIBS@|$(GNOMECANVASLIBS)|" \
	    -e "s|@SOURCEVIEW3_MLS@|$(GTKSOURCEVIEW3ALLMLOBJS:.cmo=)|" \
	    -e "s|@SOURCEVIEW3_LIBS@|$(GTKSOURCEVIEW3LIBS)|" \
	    -e "s|@TOOLCHAIN@|$(TOOLCHAIN)|" \
	    < build.ml.in > $@

gdk_pixbuf_mlsource3$(XE) : lablgtk.cma gdk_pixbuf_mlsource.ml
	$(CAMLC) -o $@ -I . $^

lablgtkopt:: $(MLLIBS:.cma=.cmxa) $(INITOBJS:.cmo=.cmx)
ifeq ($(THREADS_LIB),system)
lablgtkopt:: $(THOBJS:.cmo=.cmx)
endif

ifeq ($(HAS_NATIVE_DYNLINK),yes)
lablgtkopt::  $(MLLIBS:.cma=.cmxs)
endif

LABLGLADECCOBJS = gutf8.cmo xml_lexer.cmo lablgladecc.cmo

lablgladecc$(XE): $(LABLGLADECCOBJS)
	$(LINKER) -o $@ $(LABLGLADECCOBJS)

testcc$(XE): lablgladecc$(XE) lablgtktop
	./lablgladecc -test > testcc.ml
	./lablgtktop testcc.ml
	rm -f testcc.ml

PREOBJS= $(MLOBJS) $(EXTRAOBJS) $(RSVGMLOBJS) \
	$(GNOMECANVASMLOBJS) $(GTKSOURCEVIEW2ALLMLOBJS)

# Install ml sources and C binaries, can then rebuild using build.ml
preinstall:
	mkdir -p "$(INSTALLDIR)" "$(BINDIR)" "$(DLLDIR)"
	cp $(PREOBJS:.cmo=.ml) $(GTKSOURCEVIEW3INSTALL) "$(INSTALLDIR)"
	for f in $(PREOBJS:.cmo=.mli); do \
	  if test -f $$f; then cp $$f "$(INSTALLDIR)"; fi; done
	cp build.ml "$(INSTALLDIR)"
	cp lablgtk3$(XB) gdk_pixbuf_mlsource3$(XE) "$(BINDIR)"
	cp lablgladecc$(XE) "$(BINDIR)/lablgladecc3$(XE)"
	cp $(CLIBS) "$(INSTALLDIR)"
	cp $(CLIBS:lib%$(XA)=dll%$(XS)) "$(DLLDIR)"

# Install directly to $(INSTALLDIR), without using ocamlfind
old-install:
	mkdir -p "$(INSTALLDIR)" "$(BINDIR)" "$(DLLDIR)"
	cp $(ALLOBJS:.cmo=.cmi) $(EXTRA_OBJS:.cmo=.cmi) "$(INSTALLDIR)"
	cp -p ../META *.mli "$(INSTALLDIR)"
	cp -p $(ALLOBJS:.cmo=.ml) $(ALLTHOBJS:.cmo=.ml) \
	      $(EXTRA_OBJS:.cmo=.ml) build.ml "$(INSTALLDIR)"
	cp $(EXTRA_MLLIBS) $(MLLIBS) $(INITOBJS) "$(INSTALLDIR)"
	cp $(CLIBS) "$(INSTALLDIR)"
	cd "$(INSTALLDIR)" && $(RANLIB) $(CLIBS)
	cp varcc$(XE) propcc$(XE) "$(INSTALLDIR)"
	if test $(THREADS_LIB) != no; \
	   then cp $(ALLTHOBJS) $(ALLTHOBJS:.cmo=.cmi) "$(INSTALLDIR)"; \
	fi
	if test $(THREADS_LIB) = vm || test $(HAS_DLL_SUPPORT) != yes; \
	   then cp lablgtktop$(XE) "$(INSTALLDIR)"; \
	fi
	cp -p *.h "$(INSTALLDIR)"
	@if test -f lablgtk.cmxa; then $(MAKE) old-installopt; fi
	@if test -f dlllablgtk3$(XS); then $(MAKE) old-installdll; fi
	cp lablgtk3$(XB) "$(BINDIR)"
	if test -f lablgladecc$(XE); then \
	   cp lablgladecc$(XE) "$(BINDIR)/lablgladecc3$(XE)"; fi
	cp gdk_pixbuf_mlsource3$(XE) "$(BINDIR)"

old-installdll:
	cp $(CLIBS:lib%$(XA)=dll%$(XS)) "$(DLLDIR)" || \
	   echo "Couldn't install dlls in default location: $(DLLDIR)"
	if test -f dlllablgtk3$(XA); then \
	  cp $(CLIBS:lib%$(XA)=dll%$(XA)) "$(INSTALLDIR)"; fi

old-installopt:
	cp $(MLLIBS:.cma=.cmxa) $(MLLIBS:.cma=$(XA)) $(EXTRA_MLLIBS:.cma=.cmxa) $(EXTRA_MLLIBS:.cma=$(XA)) "$(INSTALLDIR)"
ifeq ($(HAS_NATIVE_DYNLINK),yes)
	cp $(MLLIBS:.cma=.cmxs) $(EXTRA_MLLIBS:.cma=.cmxs) "$(INSTALLDIR)"
endif
	cd "$(INSTALLDIR)" && $(RANLIB) $(MLLIBS:.cma=$(XA)) $(EXTRA_MLLIBS:.cma=$(XA))
	cp $(ALLOBJS:.cmo=.cmx) $(EXTRA_OBJS:.cmo=.cmx) "$(INSTALLDIR)"
	cp $(INITOBJS:.cmo=$(XO)) "$(INSTALLDIR)"
	if test -f gtkThread.cmx; then \
	   cp $(THOBJS:.cmo=.cmx) $(THOBJS:.cmo=$(XO)) "$(INSTALLDIR)"; fi

old-uninstall:
	rm -r "$(INSTALLDIR)"
	for f in $(CLIBS:lib%$(XA)=dll%$(XS)); \
	  do rm "$(DLLDIR)"/$$f; done
	for f in lablgladecc3$(XE) lablgtk3$(XB) gdk_pixbuf_mlsource3$(XE); \
	  do rm -f "$(BINDIR)"/$$f; done

# Install using ocamlfind
findlib-install:
	@if test "$(OCAMLFIND)" = no; then \
	  echo "Cannot use ocamlfind, use old-install."; \
	  exit 2; fi
	mkdir -p "$(BINDIR)"
	mkdir -p "$(DESTDIR)$(FINDLIBDIR)"
	@if test -f "$(DESTDIR)$(OCAMLLDCONF)"; then :; else \
	  mkdir -p "`dirname $(DESTDIR)$(OCAMLLDCONF)`"; \
	  touch "$(DESTDIR)$(OCAMLLDCONF)"; fi
	$(OCAMLFIND) install -destdir "$(DESTDIR)$(FINDLIBDIR)" \
	  -ldconf "$(DESTDIR)$(OCAMLLDCONF)" \

=== debian/changelog ===
lablgtk3 (3.0~beta3-1) unstable; urgency=medium

  * Initial packaging (closes: #916645)

 -- Ralf Treinen <treinen@debian.org>  Sun, 23 Dec 2018 20:00:19 +0100

=== debian/control ===
Source: lablgtk3
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Ralf Treinen <treinen@debian.org>,
Build-Depends:
 debhelper (>= 11),
 dh-ocaml,
 ocaml-nox (>= 4.05),
 ocaml-findlib (>= 1.2.1),
 libgtk-3-dev (>= 3.18),
 libgtkspell3-3-dev,
 libgtksourceview-3.0-dev
Build-Conflicts: liblablgtk2-ocaml-dev
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/ocaml-team/lablgtk3.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/lablgtk3

Package: liblablgtk3-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: runtime libraries for OCaml bindings for GTK+ version 3
 lablgtk3 contains bindings for GTK+ 3.x and OCaml.
 .
 This package include only the dynamic libraries needed for running dynamic
 bytecode executables.

Package: liblablgtk3-ocaml-dev
Architecture: any
Depends:
 libgtk-3-dev,
 libgtkspell-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: liblablgtk3-ocaml-doc
Description: OCaml bindings to Gtk+ version 3
 lablgtk3 contains bindings for GTK+ 3.x and OCaml.
 .
 This package contains the development files of lablgtk.

Package: liblablgtk3-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Enhances:
 liblablgtk3-ocaml-dev,
Description: OCaml bindings to Gtk+ version 3 (documentation)
 LablGTK3 contains bindings for GTK+ 3.x and OCaml.
 .
 This package contains the API reference of all libraries provided by
 LablGTK3, and the collection of examples.

Package: liblablgtksourceview3-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml bindings for libgtksourceview3 (runtime)
 This is the OCaml binding for the GtkSourceView3 widget, a text widget that
 extends the standard GTK+ 3.x text widget with syntax highlighting and other
 features typical of a source editor.
 .
 This package contains the shared runtime stub libraries.

Package: liblablgtksourceview3-ocaml-dev
Architecture: any
Depends:
 libgtksourceview-3.0-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: liblablgtk3-ocaml-doc
Description: OCaml bindings for libgtksourceview3, a source editor GTK+ widget
 This is the OCaml binding for the GtkSourceView3 widget, a text widget that
 extends the standard GTK+ 3.x text widget with syntax highlighting and other
 features typical of a source editor.
 .
 This package contains the development part of the lablgtksourceview2 package.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk
DESTDIR := $(CURDIR)/debian/tmp
export OCAMLFIND_DESTDIR=$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF=ignore

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	[ ! -f config.make ] || $(MAKE) clean

override_dh_auto_configure:
	dh_auto_configure -- --with-gtkspell --with-gtksourceview3

override_dh_auto_build:
	$(MAKE) world

override_dh_missing:
	dh_missing --list-missing

override_dh_installexamples:
	dh_installexamples
	if [ -d debian/liblablgtk3-ocaml-doc/usr/share/doc/liblablgtk3-ocaml/examples ]; \
	then \
	  find debian/liblablgtk3-ocaml-doc/usr/share/doc/liblablgtk3-ocaml/examples \
	    -name .cvsignore \
	    -delete ;\
	fi

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$// \
http://forge.ocamlcore.org/frs/?group_id=220 .*/lablgtk-(.*)\.tar\.gz

## lablgtk3 3.0~beta6

=== src/Makefile ===
--- 
+++ 
@@ -1,18 +1,19 @@
 # Makefile for lablgtk.
 
-COMPILER = $(CAMLC) $(MLFLAGS) $(MLBYTEFLAGS) -w s-3+52 -warn-error A-52 -c
+OCAMLFINDDEPS = -package cairo2
+COMPILER = $(OCAMLFIND) $(CAMLC) $(OCAMLFINDDEPS) $(MLFLAGS) $(MLBYTEFLAGS) -w s-3+52 -warn-error A-52 -c
 LINKER = $(CAMLC) $(MLFLAGS) $(MLBYTEFLAGS)
-COMPOPT = $(CAMLOPT) $(MLFLAGS) -w s -c
+COMPOPT = $(OCAMLFIND) $(CAMLOPT) $(OCAMLFINDDEPS) $(MLFLAGS) -w s -c
 LINKOPT = $(CAMLOPT) $(MLFLAGS)
 LIBRARIAN = $(CAMLMKLIB) -verbose -ocamlc "$(CAMLC)" -ocamlopt "$(CAMLOPT)"
-TOPLEVEL = $(CAMLMKTOP) $(MLFLAGS)
+TOPLEVEL = $(OCAMLFIND) $(CAMLMKTOP) $(OCAMLFINDDEPS) cairo.cma $(MLFLAGS)
 CAMLP4 = $(CAMLP4O) pr_o.cmo
 
 CONFIG = ../config.make
 
 # protect against missing definitions
 BINDIR = ""
-LIBDIR = ""
+LIBDIR = `ocamlfind query cairo2`
 INSTALLDIR = $(LIBDIR)/lablgtk3
 DLLDIR = $(LIBDIR)/stublibs
 
@@ -43,6 +44,8 @@
 ifdef ABSVALUE
 GTKCFLAGS += -Iabsvalue -DABSVALUE
 endif
+
+GTKCFLAGS += -I`ocamlfind query cairo2`
 
 ifdef DEBUG
 CFLAGS = -g $(GTKCFLAGS)
@@ -192,26 +195,27 @@
 	ml_gtkpack$(XO) ml_gtkrange$(XO) ml_gtkstock$(XO) \
 	ml_gtktext$(XO) ml_gtktree$(XO) ml_gtkbuilder$(XO)
 COBJS = ml_gdkpixbuf$(XO) ml_gdk$(XO) ml_glib$(XO) ml_gobject$(XO) \
-	ml_gpointer$(XO) ml_gvaluecaml$(XO) wrappers$(XO) $(GTKOBJS)
-GTKPROPS += gtkBase.props gtkBin.props gtkButton.props gtkEdit.props \
-	gtkMenu.props gtkMisc.props gtkPack.props \
+	ml_gpointer$(XO) ml_gvaluecaml$(XO) wrappers$(XO) $(GTKOBJS) \
+        cairo_pango_stubs$(XO)
+GTKPROPS += gtkBase.props gtkContainers.props gtkBin.props gtkButton.props \
+        gtkEdit.props gtkMenu.props gtkMisc.props gtkPack.props \
 	gtkRange.props gtkText.props gtkTree.props gtkFile.props \
 	gtkAction.props gtkAssistant.props gtkBuilder.props
 MLOBJS1 =  gaux.cmo gpointer.cmo gutf8.cmo glib.cmo gobject.cmo
 ENUMOBJS += gdkEnums.cmo pangoEnums.cmo gtkEnums.cmo
 MLOBJS2 = pango.cmo gdk.cmo gdkEvent.cmo gdkKeysyms.cmo gdkPixbuf.cmo \
 	gtk.cmo gtkSignal.cmo gtkStock.cmo gtkObject.cmo
-MLOBJS3 = gtkData.cmo gtkBase.cmo gtkPack.cmo gtkButton.cmo \
+MLOBJS3 = gtkData.cmo gtkBase.cmo gtkContainers.cmo gtkPack.cmo gtkButton.cmo \
 	gtkAssistant.cmo \
 	gtkMenu.cmo gtkMisc.cmo gtkWindow.cmo \
 	gtkBin.cmo gtkEdit.cmo gtkRange.cmo gtkText.cmo gtkTree.cmo \
 	gtkBuilder.cmo gtkFile.cmo gtkMain.cmo \
-	gPango.cmo gDraw.cmo gObj.cmo ogtkBaseProps.cmo gData.cmo
+	gPango.cmo gDraw.cmo ogtkBaseProps.cmo gObj.cmo gData.cmo
 MLOBJS4 = gMain.cmo gContainer.cmo gPack.cmo gButton.cmo gText.cmo \
 	gMenu.cmo gMisc.cmo gTree.cmo gFile.cmo gWindow.cmo \
 	gAssistant.cmo gBuilder.cmo \
 	gBin.cmo gEdit.cmo gRange.cmo gAction.cmo \
-	gUtil.cmo gToolbox.cmo
+	gUtil.cmo gToolbox.cmo cairo_pango.cmo
 MLOBJS =  $(MLOBJS1) $(ENUMOBJS) $(MLOBJS2) $(GTKPROPS:.props=Props.cmo) \
 	$(MLOBJS3) $(GTKPROPS:%.props=o%Props.cmo) $(MLOBJS4)
 THOBJS = gtkThread.cmo
@@ -281,7 +285,7 @@
 	    < build.ml.in > $@
 
 gdk_pixbuf_mlsource3$(XE) : lablgtk.cma gdk_pixbuf_mlsource.ml
-	$(CAMLC) -o $@ -I . $^
+	$(OCAMLFIND) $(CAMLC) $(OCAMLFINDDEPS) -o $@ -I . cairo.cma $^
 
 lablgtkopt:: $(MLLIBS:.cma=.cmxa) $(INITOBJS:.cmo=.cmx)
 ifeq ($(THREADS_LIB),system)
@@ -370,11 +374,3 @@
 findlib-install:
 	@if test "$(OCAMLFIND)" = no; then \
 	  echo "Cannot use ocamlfind, use old-install."; \
-	  exit 2; fi
-	mkdir -p "$(BINDIR)"
-	mkdir -p "$(DESTDIR)$(FINDLIBDIR)"
-	@if test -f "$(DESTDIR)$(OCAMLLDCONF)"; then :; else \
-	  mkdir -p "`dirname $(DESTDIR)$(OCAMLLDCONF)`"; \
-	  touch "$(DESTDIR)$(OCAMLLDCONF)"; fi
-	$(OCAMLFIND) install -destdir "$(DESTDIR)$(FINDLIBDIR)" \
-	  -ldconf "$(DESTDIR)$(OCAMLLDCONF)" \

=== src/introspection/Makefile ===
OCAMLC=ocamlc
OPT=-g -dtypes
INCLUDES= -I xml-light xml-light.cma 
GIRA=/usr/share/gir-1.0/Gtk-3.0.gir
GIR=Gtk-3.0

all: high check

extract_stubs: extract_prototype.ml xml-light/xml-light.cma
	$(OCAMLC) $(OPT) $(INCLUDES) -o $@ $^

test: extract_stubs
	./extract_stubs $(GIRA) > LOG

check: test
	cd stubs ; ocamlc -c -ccopt '`pkg-config --cflags gtk+-3.0`' ml_stubs_Gtk.c

clean:
	rm -f extract_stubs *.annot extract_prototype.cm* ml_stubs.c stubs.ml
	$(MAKE) -C xml-light clean

xml-light/xml-light.cma:
	$(MAKE) -C xml-light

################################################################


high: $(GIR).props propcc link
	./propcc $<
.PHONY: all

link: $(GIRA)
	ln -f -s $(GIRA) .

$(GIR).props: $(GIR).gir gir_to_props.xsl
	xsltproc -o $@ gir_to_props.xsl $<

#$(GIR): /usr/lib/x86_64-linux-gnu/girepository-1.0/Gtk-3.0.typelib
	#g-ir-generate -o $@ $<

propcc.ml: propcc.ml4
	camlp4o -impl $< -o $@

propcc.cmo: propcc.ml genlex.cmo
	ocamlc -c $<

genlex.cmo: genlex.ml
	ocamlc -c $<

propcc: propcc.cmo genlex.cmo
	ocamlc -o $@ genlex.cmo $<

=== debian/changelog ===
lablgtk3 (3.0~beta6-2build1) focal; urgency=medium

  * No-change rebuild against ocaml-nox-4.08.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Feb 2020 07:23:01 +0000

lablgtk3 (3.0~beta6-2) unstable; urgency=medium

  * Package liblablgtk3-ocaml-dev: add breaks/replaces with
    liblablgtk3-ocaml (<< 3.0~beta6-1) since the META file was
    moved from the latter to the first (closes: Bug#935611)
  * Add to override dh_ocaml more units that are also exported by
    lablgtk2-ocaml-dev: GPointer, Glib
  * Fix a typo in long description of liblablgtk3-ocaml

 -- Ralf Treinen <treinen@debian.org>  Mon, 26 Aug 2019 09:44:41 +0200

lablgtk3 (3.0~beta6-1) unstable; urgency=medium

  * New upstream beta release
  * New binary packages liblablgtkspell3-ocaml-dev, liblablgtkspell3-ocaml
  * d/watch:
    - point to release tags on github
    - set uversionmangle to handle correctly ".beta" versions
  * Build-dependencies:
    - add libcairo2-ocaml-dev
    - add ocaml-dune and libdune-ocaml-dev
    - change ocaml-nox to ocaml
    - change debhelper(=11) to debhelper-compat(=12), drop file debian/compat
  * Drop build-conflict on liblablgtk2-ocaml-dev
  * Improve package descriptions
  * Installation into binary packages:
    - change debian/*install.in files to follow the new file layout created
      by "dune install"
    - install useful upstream docs into liblablgtk-ocaml-dev
    - do not install binaries lablgladecc3 and gdk_pixbuf_mlsource3
  * debian/rules:
    - build: call dune -p ... (thanks to @ejgallego for the hint)
    - clean: call dune
    - install: call dune
    - configure: do nothing, since dune does its own configuration.
    - drop unused variable settings from d/rules
    - dh_missing: switch to --fail-missing
    - override dh_ocaml to avoid conflicts on units that are also
      exported by lablgtk2-ocaml-dev
  * debian/copyright:
    - drop a spurious blank line
  * Package tests:
    - update compilation option for lablgtk3-dev
  * Add Homepage
  * Standards-Version 4.4.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Tue, 13 Aug 2019 09:18:16 +0200

=== debian/control ===
Source: lablgtk3
Section: ocaml
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Ralf Treinen <treinen@debian.org>,
Build-Depends:
 debhelper-compat (= 12),
 dh-ocaml,
 ocaml (>= 4.05),
 ocaml-dune (>= 1.4.0),
 libdune-ocaml-dev,
 ocaml-findlib (>= 1.2.1),
 libgtk-3-dev (>= 3.18),
 libgtkspell3-3-dev,
 libgtksourceview-3.0-dev,
 libcairo2-ocaml-dev
Standards-Version: 4.4.0
Vcs-Git: https://salsa.debian.org/ocaml-team/lablgtk3.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/lablgtk3
Homepage: https://github.com/garrigue/lablgtk

Package: liblablgtk3-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description:  OCaml bindings to Gtk+ version 3 (runtime) 
 This is the OCaml binding for GTK+ version 3. GTK stands for the GIMP Toolkit,
 a multi-platform toolkit for creating graphical user interfaces.
 .
 This package includes only the dynamic libraries needed for running dynamic
 bytecode executables.

Package: liblablgtk3-ocaml-dev
Architecture: any
Depends:
 libgtk-3-dev,
 libgtkspell-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Breaks: liblablgtk3-ocaml (<< 3.0~beta6-1)
Replaces: liblablgtk3-ocaml (<< 3.0~beta6-1)
Recommends:
Description: OCaml bindings to Gtk+ version 3 (development files)
 This is the OCaml binding for GTK+ version 3. GTK stands for the GIMP Toolkit,
 a multi-platform toolkit for creating graphical user interfaces.
 .
 This package contains the development files of lablgtk.

Package: liblablgtk3-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Enhances:
 liblablgtk3-ocaml-dev,
Description: OCaml bindings to Gtk+ version 3 (documentation)
 This is the OCaml binding for GTK+ version 3. GTK stands for the GIMP Toolkit,
 a multi-platform toolkit for creating graphical user interfaces.
 .
 This package contains the API reference of all libraries provided by
 LablGTK3, and the collection of examples.

Package: liblablgtksourceview3-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml bindings for libgtksourceview3 (runtime)
 This is the OCaml binding for the GtkSourceView3 widget, a text widget that
 extends the standard GTK+ 3.x text widget with syntax highlighting and other
 features typical of a source editor.
 .
 This package contains the shared runtime stub libraries.

Package: liblablgtksourceview3-ocaml-dev
Architecture: any
Depends:
 libgtksourceview-3.0-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: liblablgtk3-ocaml-doc
Description: OCaml bindings for libgtksourceview3 (development files)
 This is the OCaml binding for the GtkSourceView3 widget, a text widget that
 extends the standard GTK+ 3.x text widget with syntax highlighting and other
 features typical of a source editor.
 .
 This package contains the development files of the lablgtksourceview3 package.

Package: liblablgtkspell3-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml bindings for libgtkspell3 (runtime)
 This is the OCaml binding for the GtkSpell library which provides
 word-processor-style highlighting and replacement of misspelled words
 in a GtkTextView widget.
 .
 This package contains the shared runtime stub libraries.

Package: liblablgtkspell3-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: liblablgtk3-ocaml-doc
Description: OCaml bindings for libgtkspell3 (development files)
 This is the OCaml binding for the GtkSpell library which provides
 word-processor-style highlighting and replacement of misspelled words
 in a GtkTextView widget.
 .
 This package contains the development files of the lablgtkspell3 package.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	dune clean

override_dh_auto_configure:
	# do nothing

override_dh_auto_build:
	dune build -p lablgtk3,lablgtk3-sourceview3,lablgtk3-gtkspell3

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp dune install

override_dh_missing:
	dh_missing --fail-missing

override_dh_installexamples:
	dh_installexamples
	if [ -d debian/liblablgtk3-ocaml-doc/usr/share/doc/liblablgtk3-ocaml/examples ]; \
	then \
	  find debian/liblablgtk3-ocaml-doc/usr/share/doc/liblablgtk3-ocaml/examples \
	    -name .cvsignore \
	    -delete ;\
	fi

override_dh_ocaml:
	dh_ocaml --nodefined-map=liblablgtk3-ocaml-dev:GtkThread \
		--nodefined-map=liblablgtk3-ocaml-dev:Gobject \
		--nodefined-map=liblablgtk3-ocaml-dev:GtkSignal \
		--nodefined-map=liblablgtk3-ocaml-dev:Gaux \
		--nodefined-map=liblablgtk3-ocaml-dev:Gutf8 \
		--nodefined-map=liblablgtk3-ocaml-dev:Gpointer \
		--nodefined-map=liblablgtk3-ocaml-dev:Glib \

=== debian/tests/control ===
Tests: lablgtk3-dev
Depends: ocaml-nox, ocaml-findlib, liblablgtk3-ocaml-dev

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, uversionmangle=s/\.beta/~beta/" \
	 https://github.com/garrigue/lablgtk.git \
         refs/tags/(3.[\d*].*)

## lablgtk3 3.1.0

=== debian/changelog ===
lablgtk3 (3.1.0-3) unstable; urgency=medium

  * Patch gcc10: fix compilation with gcc10 (closes: #957414)

 -- Ralf Treinen <treinen@debian.org>  Fri, 17 Apr 2020 21:39:33 +0200

lablgtk3 (3.1.0-2) unstable; urgency=medium

  * Upload to sid

 -- Ralf Treinen <treinen@debian.org>  Tue, 07 Apr 2020 09:33:07 +0200

lablgtk3 (3.1.0-1) experimental; urgency=medium

  * New upstream version
  * Standards-Version 4.5.0 (no change)
  * drop override of dh_auto_build which is no longer useful
  * Add build-dependency camlp5
  * Add build-conflict on liblablgtk3-ocaml, in order to avoid that a
    dependency on the version installed on the system is picked up.
  * Bump build-dependencies of ocaml-dune and libcairo2-ocaml-dev.

 -- Ralf Treinen <treinen@debian.org>  Thu, 20 Feb 2020 09:01:24 +0100

lablgtk3 (3.0~beta8-1) experimental; urgency=medium

  * New upstream beta release
  * Add usr/doc/lablgtk3/LICENSE to debian/not-installed
  * Mark package liblablgtk3-ocaml-doc as Multi-Arch: foreign
  * Standards-Version 4.4.1 (no change)
  * Install METAs, cmxs files and the corresponding .cma files into the
    runtime library packages (closes: #935870)
  * Consequently, add Replaces/Breaks of the runtime library packages
    with earlier versions of the corresponding -dev packages.
  * debian/rules: construct the installation lists of the -dev packages
    by taking all generated files that are not to be installed into the
    respective runtime packages.
  * debian/rules: drop override of dh_installexamples which is no longer
    needed as upstream has removed the stale .cvsignore files.

 -- Ralf Treinen <treinen@debian.org>  Tue, 21 Jan 2020 08:31:38 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,24 @@
 Source: lablgtk3
 Section: ocaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Ralf Treinen <treinen@debian.org>,
 Build-Depends:
  debhelper-compat (= 12),
  dh-ocaml,
  ocaml (>= 4.05),
- ocaml-dune (>= 1.4.0),
+ ocaml-dune (>= 1.8.0),
  libdune-ocaml-dev,
+ camlp5,
  ocaml-findlib (>= 1.2.1),
  libgtk-3-dev (>= 3.18),
  libgtkspell3-3-dev,
  libgtksourceview-3.0-dev,
- libcairo2-ocaml-dev
-Standards-Version: 4.4.0
+ libcairo2-ocaml-dev (>= 0.6)
+Build-Conflicts:
+ liblablgtk3-ocaml
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/ocaml-team/lablgtk3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/lablgtk3
 Homepage: https://github.com/garrigue/lablgtk
@@ -28,6 +30,8 @@
  ${shlibs:Depends},
  ${misc:Depends}
 Provides: ${ocaml:Provides}
+Breaks: liblablgtk3-ocaml-dev (<< 3.0~beta8-1)
+Replaces: liblablgtk3-ocaml-dev (<< 3.0~beta8-1)
 Description:  OCaml bindings to Gtk+ version 3 (runtime) 
  This is the OCaml binding for GTK+ version 3. GTK stands for the GIMP Toolkit,
  a multi-platform toolkit for creating graphical user interfaces.
@@ -58,7 +62,8 @@
 Architecture: all
 Depends: ${misc:Depends}
 Enhances:
- liblablgtk3-ocaml-dev,
+ liblablgtk3-ocaml-dev
+Multi-Arch: foreign
 Description: OCaml bindings to Gtk+ version 3 (documentation)
  This is the OCaml binding for GTK+ version 3. GTK stands for the GIMP Toolkit,
  a multi-platform toolkit for creating graphical user interfaces.
@@ -73,6 +78,8 @@
  ${shlibs:Depends},
  ${misc:Depends}
 Provides: ${ocaml:Provides}
+Breaks: liblablgtksourceview3-ocaml-dev (<< 3.0~beta8-1)
+Replaces: liblablgtksourceview3-ocaml-dev (<< 3.0~beta8-1)
 Description: OCaml bindings for libgtksourceview3 (runtime)
  This is the OCaml binding for the GtkSourceView3 widget, a text widget that
  extends the standard GTK+ 3.x text widget with syntax highlighting and other
@@ -103,6 +110,8 @@
  ${shlibs:Depends},
  ${misc:Depends}
 Provides: ${ocaml:Provides}
+Breaks: liblablgtkspell3-ocaml-dev (<< 3.0~beta8-1)
+Replaces: liblablgtkspell3-ocaml-dev (<< 3.0~beta8-1)
 Description: OCaml bindings for libgtkspell3 (runtime)
  This is the OCaml binding for the GtkSpell library which provides
  word-processor-style highlighting and replacement of misspelled words

=== debian/rules ===
--- 
+++ 
@@ -12,23 +12,30 @@
 override_dh_auto_configure:
 	# do nothing
 
-override_dh_auto_build:
-	dune build -p lablgtk3,lablgtk3-sourceview3,lablgtk3-gtkspell3
-
 override_dh_auto_install:
 	DESTDIR=$(CURDIR)/debian/tmp dune install
+	# install into liblablgtk3-ocaml-dev all regular files of the
+	# lablgtk3 dir that are not to be installed into liblablgtk3-ocaml
+	# Same for liblablgtksourceview3 and liblablgtkspell3
+	(cd $(CURDIR)/debian/tmp; \
+	 find usr/lib/ocaml/lablgtk3 \
+	   -type f \
+	   ! -exec grep -q '{}' ../liblablgtk3-ocaml.install \;\
+	   -print \
+	   >> ../liblablgtk3-ocaml-dev.install; \
+	 find usr/lib/ocaml/lablgtk3-sourceview3 \
+	   -type f \
+	   ! -exec grep -q '{}' ../liblablgtksourceview3-ocaml.install \;\
+	   -print \
+	   >> ../liblablgtksourceview3-ocaml-dev.install; \
+	 find usr/lib/ocaml/lablgtk3-gtkspell3 \
+	   -type f \
+	   ! -exec grep -q '{}' ../liblablgtkspell3-ocaml.install \;\
+	   -print \
+	   >> ../liblablgtkspell3-ocaml-dev.install)
 
 override_dh_missing:
 	dh_missing --fail-missing
-
-override_dh_installexamples:
-	dh_installexamples
-	if [ -d debian/liblablgtk3-ocaml-doc/usr/share/doc/liblablgtk3-ocaml/examples ]; \
-	then \
-	  find debian/liblablgtk3-ocaml-doc/usr/share/doc/liblablgtk3-ocaml/examples \
-	    -name .cvsignore \
-	    -delete ;\
-	fi
 
 override_dh_ocaml:
 	dh_ocaml --nodefined-map=liblablgtk3-ocaml-dev:GtkThread \

## lablgtk3 3.1.1

=== debian/changelog ===
lablgtk3 (3.1.1-1build2) groovy; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 24 Aug 2020 12:52:51 +0200

lablgtk3 (3.1.1-1build1) groovy; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Aug 2020 08:38:24 +0200

lablgtk3 (3.1.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Fix dependency on libgtkspell3-3-dev (Closes: #967893)
  * Bump debhelper compat level to 13
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Aug 2020 11:06:07 +0200

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+include /usr/share/ocaml/ocamlvars.mk
 
 %:
 	dh $@ --with ocaml
@@ -11,6 +13,9 @@
 
 override_dh_auto_configure:
 	# do nothing
+
+override_dh_auto_build:
+	dune build
 
 override_dh_auto_install:
 	DESTDIR=$(CURDIR)/debian/tmp dune install
@@ -34,9 +39,6 @@
 	   -print \
 	   >> ../liblablgtkspell3-ocaml-dev.install)
 
-override_dh_missing:
-	dh_missing --fail-missing
-
 override_dh_ocaml:
 	dh_ocaml --nodefined-map=liblablgtk3-ocaml-dev:GtkThread \
 		--nodefined-map=liblablgtk3-ocaml-dev:Gobject \

## lablgtk3 3.1.1+official

=== examples/text/Makefile ===
all: unicode_table unicode_viewer

unicode_table: unicode_table.ml
	ocamlfind ocamlc -package lablgtk2 -linkpkg -o unicode_table $<
unicode_table.opt: unicode_table.ml
	ocamlfind ocamlopt -package lablgtk2 -linkpkg -o unicode_table $<

unicode_viewer: unicode_viewer.ml
	ocamlfind ocamlc -package lablgtk2 -linkpkg -o unicode_viewer $<
clean:
	rm *.cm* *.o unicode_viewer unicode_table

=== debian/changelog ===
lablgtk3 (3.1.1+official-1) unstable; urgency=medium

  * Use an official upstream tarball, instead of a tag on the upstream git.
  * d/rules: give explicit list of packages to dune (closes: #971439)
  * Change debian/watch to download official tarballs, instead of tagged
    releases from git.

 -- Ralf Treinen <treinen@debian.org>  Thu, 01 Oct 2020 21:47:51 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Ralf Treinen <treinen@debian.org>,
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-ocaml,
  ocaml (>= 4.05),
  ocaml-dune (>= 1.8.0),
@@ -19,6 +19,7 @@
 Build-Conflicts:
  liblablgtk3-ocaml
 Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/lablgtk3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/lablgtk3
 Homepage: https://github.com/garrigue/lablgtk
@@ -32,7 +33,7 @@
 Provides: ${ocaml:Provides}
 Breaks: liblablgtk3-ocaml-dev (<< 3.0~beta8-1)
 Replaces: liblablgtk3-ocaml-dev (<< 3.0~beta8-1)
-Description:  OCaml bindings to Gtk+ version 3 (runtime) 
+Description: OCaml bindings to Gtk+ version 3 (runtime)
  This is the OCaml binding for GTK+ version 3. GTK stands for the GIMP Toolkit,
  a multi-platform toolkit for creating graphical user interfaces.
  .
@@ -43,14 +44,12 @@
 Architecture: any
 Depends:
  libgtk-3-dev,
- libgtkspell-dev,
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
 Provides: ${ocaml:Provides}
 Breaks: liblablgtk3-ocaml (<< 3.0~beta6-1)
 Replaces: liblablgtk3-ocaml (<< 3.0~beta6-1)
-Recommends:
 Description: OCaml bindings to Gtk+ version 3 (development files)
  This is the OCaml binding for GTK+ version 3. GTK stands for the GIMP Toolkit,
  a multi-platform toolkit for creating graphical user interfaces.
@@ -122,6 +121,7 @@
 Package: liblablgtkspell3-ocaml-dev
 Architecture: any
 Depends:
+ libgtkspell3-3-dev,
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 	# do nothing
 
 override_dh_auto_build:
-	dune build
+	dune build -p lablgtk3,lablgtk3-gtkspell3,lablgtk3-sourceview3
 
 override_dh_auto_install:
 	DESTDIR=$(CURDIR)/debian/tmp dune install

=== debian/watch ===
version=4
opts="pgpmode=none, uversionmangle=s/\.beta/~beta/" \
	 https://github.com/garrigue/lablgtk/releases/tag/3.1.1 \
	 .*/lablgtk3-([.\d]+)\.tbz

## lablgtk3 3.1.2

=== tools/introspection/Makefile ===
OCAMLC=ocamlc
OPT=-g -dtypes
INCLUDES= -I xml-light xml-light.cma 
GIRA=/usr/share/gir-1.0/Gtk-3.0.gir
GIR=Gtk-3.0

all: high check

extract_stubs: extract_prototype.ml xml-light/xml-light.cma
	$(OCAMLC) $(OPT) $(INCLUDES) -o $@ $^

test: extract_stubs
	./extract_stubs $(GIRA) > LOG

check: test
	cd stubs ; ocamlc -c -ccopt '`pkg-config --cflags gtk+-3.0`' ml_stubs_Gtk.c

clean:
	rm -f extract_stubs *.annot extract_prototype.cm* ml_stubs.c stubs.ml
	$(MAKE) -C xml-light clean

xml-light/xml-light.cma:
	$(MAKE) -C xml-light

################################################################


high: $(GIR).props propcc link
	./propcc $<
.PHONY: all

link: $(GIRA)
	ln -f -s $(GIRA) .

$(GIR).props: $(GIR).gir gir_to_props.xsl
	xsltproc -o $@ gir_to_props.xsl $<

#$(GIR): /usr/lib/x86_64-linux-gnu/girepository-1.0/Gtk-3.0.typelib
	#g-ir-generate -o $@ $<

propcc.ml: propcc.ml4
	camlp5o -impl $< -o $@

propcc.cmo: propcc.ml genlex.cmo
	ocamlc -c $<

genlex.cmo: genlex.ml
	ocamlc -c $<

propcc: propcc.cmo genlex.cmo
	ocamlc -o $@ genlex.cmo $<

=== debian/changelog ===
lablgtk3 (3.1.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Update debian/watch
  * Bump Standards-Version to 4.6.0

 -- Stéphane Glondu <glondu@debian.org>  Wed, 02 Mar 2022 08:14:43 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  libcairo2-ocaml-dev (>= 0.6)
 Build-Conflicts:
  liblablgtk3-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/lablgtk3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/lablgtk3

## lablgtk3 3.1.3

=== Makefile ===
.PHONY: help release dev dev-all nopromote opam clean

help:
	@echo "Welcome to lablgtk Dune-based build system. Targets are"
	@echo ""
	@echo "  - release:   build lablgtk package in release mode"
	@echo "  - dev:       build in developer mode [requires extra dependencies]"
	@echo "  - dev-all:   build in developer mode [requires extra dependencies]"
	@echo "  - nopromote: dev build but without re-running camlp5 generation"
	@echo "  - opam:      internal, used in CI testing"
	@echo "  - clean:     clean build tree"
	@echo ""
	@echo "WARNING: Packagers should not use this makefile, but call dune"
	@echo "directly with the right options for their distribution, see README"

release:
	dune build -p lablgtk3

dev:
	dune build

# This also builds examples, will be the default once we set (lang dune 2.0)
dev-all:
	dune build @all

nopromote:
	dune build @all --ignore-promoted-rules

# We first pin lablgtk3 as to avoid problems with parallel make
opam:
	opam pin add lablgtk3 . --kind=path -y
	opam install lablgtk3
	opam pin add lablgtk3-sourceview3 . --kind=path -y
	opam install lablgtk3-sourceview3
	opam pin add lablgtk3-gtkspell3 . --kind=path -y
	opam install lablgtk3-gtkspell3

clean:
	dune clean

=== debian/changelog ===
lablgtk3 (3.1.3-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * New upstream release

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on ocaml (>= 4.05).
    + Build-Depends: Drop versioned constraint on ocaml-findlib (>= 1.2.1).
    + Build-Depends: Drop versioned constraint on libgtk-3-dev (>= 3.18).
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Stéphane Glondu <glondu@debian.org>  Sat, 21 Jan 2023 09:13:15 +0100

=== debian/control ===
--- 
+++ 
@@ -7,18 +7,19 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-ocaml,
- ocaml (>= 4.05),
+ ocaml,
  ocaml-dune (>= 1.8.0),
  libdune-ocaml-dev,
  camlp5,
- ocaml-findlib (>= 1.2.1),
- libgtk-3-dev (>= 3.18),
+ ocaml-findlib,
+ libgtk-3-dev,
  libgtkspell3-3-dev,
  libgtksourceview-3.0-dev,
+ libcamlp-streams-ocaml-dev,
  libcairo2-ocaml-dev (>= 0.6)
 Build-Conflicts:
  liblablgtk3-ocaml
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/lablgtk3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/lablgtk3

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 	dune build -p lablgtk3,lablgtk3-gtkspell3,lablgtk3-sourceview3
 
 override_dh_auto_install:
-	DESTDIR=$(CURDIR)/debian/tmp dune install
+	DESTDIR=$(CURDIR)/debian/tmp dune install lablgtk3 lablgtk3-gtkspell3 lablgtk3-sourceview3
 	# install into liblablgtk3-ocaml-dev all regular files of the
 	# lablgtk3 dir that are not to be installed into liblablgtk3-ocaml
 	# Same for liblablgtksourceview3 and liblablgtkspell3

=== debian/watch ===
version=4
opts="pgpmode=none, uversionmangle=s/\.beta/~beta/" \
	 https://github.com/garrigue/lablgtk/releases \
	 .*/v?(3\.[.\d]+)\.tar\.gz

## lablgtk3 3.1.4

=== debian/changelog ===
lablgtk3 (3.1.4-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:38:28 +0000

lablgtk3 (3.1.4-1build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 22:56:23 +0000

lablgtk3 (3.1.4-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:16:19 +0000

lablgtk3 (3.1.4-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sun, 18 Feb 2024 12:01:12 +0100

lablgtk3 (3.1.3-2) unstable; urgency=medium

  * Team upload
  * Use ocaml_dune DH buildsystem (Closes: #1042100)
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Thu, 27 Jul 2023 05:40:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: lablgtk3
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Ralf Treinen <treinen@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- dh-ocaml,
+ dh-ocaml (>= 1.2.2),
  ocaml,
  ocaml-dune (>= 1.8.0),
  libdune-ocaml-dev,
@@ -19,7 +20,7 @@
  libcairo2-ocaml-dev (>= 0.6)
 Build-Conflicts:
  liblablgtk3-ocaml
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/lablgtk3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/lablgtk3

## lablgtk3 3.1.5

=== debian/changelog ===
lablgtk3 (3.1.5-1build4) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 02 Jul 2025 06:22:25 +0200

lablgtk3 (3.1.5-1build3) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 19 Jun 2025 11:06:37 +0200

lablgtk3 (3.1.5-1build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jan 2025 22:23:34 +0100

lablgtk3 (3.1.5-1build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:49:18 +0200

lablgtk3 (3.1.5-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 13 Jul 2024 10:44:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lablgtk3
 Section: ocaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Ralf Treinen <treinen@debian.org>,
 Build-Depends:
